#include<avr/io.h>
#include<avr/interrupt.h>
#include<stdlib.h>
#include<avr/sleep.h>
#include<avr/power.h>

#define DATABUFSIZE		42					// ްɏՕe
#define NUMBER_OFSET	34					// ްɏՕJԂ񐔕擪ʒu

char demoBuff[DATABUFSIZE] = {'M','o','r','e',' ','o','o','m','f',' ','t','o',' ','y','o','u','r',' ','a','m','p','s',',',' ','p','i','c','o','P','o','w','e','r','!',0,0,0,0,0,'\r','\n'};
uint16_t iteration=1;

ISR(TIMER2_OVF_vect)
{
	int count;

	ADMUX |= (1<<REFS1) | (1<<REFS0);		// 1.1Vd
	ADCSRA |= (1<< ADSC);					// A/DϊJn
	while(!(ADCSRA & (1<<ADIF)));			// A/Dϊҋ@
	ADMUX &= (1<<MUX3);						// 1.1Vd֎~

	utoa(iteration, &demoBuff[NUMBER_OFSET], 10);	// 10iJԂ񐔕𐶐

	__asm__ volatile (						// 1000̏[s(:ȉ̖߂ł1000ł͂Ȃ100ɂȂ܂B)
		"ldi r24, 25" "\n\t"				// (R24ɑl25ݒ)
		"1: sbiw r24,1" "\n\t"				// (R25:R24-1)
		"brne 1b"							// (R24=0܂ŌJԂp(1JԂ4܂))
	);

	for(count=0;count<DATABUFSIZE;++count)
	{
		while(!(UCSR0A & (1<<UDRE0)));		// USARTް ڼ޽󂫑ҋ@
		UDR0 = demoBuff[count];				// Ή޲Ăް ڼ޽ɐݒ(ʂƂđM)
	}
	iteration++;							// JԂvis(+1)
}

void init_adc()
{
	ADMUX = (1<<MUX3);						// dxmɐݒ
	ADCSRA = (1<<ADEN);						// A/Dϊ틖
}

void init_timer2()
{
	TCCR2B = (1<<CS20) | (1<<CS22);			// 128Ou(32.768kHz/128/256=1b)Ŏn
	TIMSK2 = (1<<TOIE2);					// /2ꊄ荞݋
	ASSR = (1<<AS2);						// 񓯊`ԋ
}

void init_uart()
{
	UCSR0A = (1<<U2X0);						// Ȃ덷]TްڰĂ𓾂邽߂ɔ{싖
	UCSR0B = (1<<TXEN0);					// M
	UCSR0C = (1<<UCSZ00) | (1<<UCSZ01);		// 񓯊,èȂ,1~ޯ,8ޯ ްw
	UBRR0 = 0x0C;							// 19200bps@2MHzw
}


void enable_pullups()
{
	PORTB = 0xFF;							// o݂̓ٱߋ(ޯĂ͊0()ɐݒ)
	PORTC = 0xFF;							// USARTTXD݂͖܂B
	PORTD = 0xFF;
}

void enable_prr()
{
	power_spi_disable();
	power_timer0_disable();
	power_timer1_disable();
	power_twi_disable();
}

void cal_clock()
{
	OSCCAL = 0x66;							// U8MHzɍZ
}

int main()
{
	cal_clock();
	clock_prescale_set(clock_div_4);		//  ۯ2MHzɑOu

	enable_prr();
	enable_pullups();

	init_uart();
	init_timer2();
	init_adc();

	set_sleep_mode(SLEEP_MODE_PWR_SAVE);	// x~`ԂܰނɎw
	sleep_enable();							// x~(SLEEPߎs޲x~`ԂɒuƂ\)
	sei();									// S̊荞݋

	while(1)
	{

		while(!(UCSR0A & (1<<UDRE0)));		// ޲x~ɒuOް ڼ޽ۏ(:AsQ)
											// (:ܰޓ`ԒUSART삪~邽߁A
											// M܂͖Mް݂Ă͂Ȃ܂B]āA
											// SȑMۏ؂ɂUDRE0ł͂ȂTXC0łȂ΂Ȃ܂B)
		sleep_bod_disable();				// x~`Ԓ̒do(BOD)֎~
		sleep_cpu();						// SLEEPߎs
	}
	return 0;
}
